import logging
import requests
import json

def choose_ip(config):
    myip = config.get('me')['ip']
    if 'dnsip' in config.get('me'):
        myip = config.get('me')['dnsip']
    return myip

def check_primary_dns(config):

    dnsapi = config.get('dnsapi')
    keyid = dnsapi['key']
    secret = dnsapi['secret']
    domain = dnsapi['domain']
    primary_hostname = dnsapi['primary_hostname']

    r  = requests.get(f"https://api.mythic-beasts.com/dns/v2/zones/{domain}/records/{primary_hostname}/AAAA", auth=(keyid, secret))
    if not r:
        raise Exception(f"An error occurred checking DNS records")

    j=json.loads(r.content)
    if 'records' in j and 'data' in j['records'][0]: 
        record = (j['records'][0]['data'])
        myip = choose_ip(config)
        if record == myip:
            return True
            
    return False


def update_primary_dns(check, config):

    dnsapi = config.get('dnsapi')
    keyid = dnsapi['key']
    secret = dnsapi['secret']
    domain = dnsapi['domain']
    primary_hostname = dnsapi['primary_hostname']
    myip = myip = choose_ip(config)

    if check_primary_dns(config):
        logging.info("DNS: Already pointing at this server")
        return
    else:
        logging.info("DNS: Not pointing at this server")


    if check:
        logging.info(f"DNS: Would update DNS to point to this server {myip}")
    else:
        logging.info(f"DNS: Updating DNS to point to this server {myip}")

        r  = requests.put(f"https://api.mythic-beasts.com/dns/v2/zones/{domain}/records/{primary_hostname}/AAAA", data= {'data': myip, 'ttl':'10' }, auth=(keyid, secret))
        if not r:
            raise Exception(f"An error occurred updating DNS")

